@:native("THREE")
extern class THREE{

public var Object3DCount:Float;
public var GeometryCount:Float;
public var MaterialCount:Float;
public var NoShading:Float;
public var FlatShading:Float;
public var SmoothShading:Float;
public var NoColors:Float;
public var FaceColors:Float;
public var VertexColors:Float;
public var NoBlending:Float;
public var NormalBlending:Float;
public var AdditiveBlending:Float;
public var SubtractiveBlending:Float;
public var MultiplyBlending:Float;
public var AdditiveAlphaBlending:Float;
public var CustomBlending:Float;
public var AddEquation:Float;
public var SubtractEquation:Float;
public var ReverseSubtractEquation:Float;
public var ZeroFactor:Float;
public var OneFactor:Float;
public var SrcColorFactor:Float;
public var OneMinusSrcColorFactor:Float;
public var SrcAlphaFactor:Float;
public var OneMinusSrcAlphaFactor:Float;
public var DstAlphaFactor:Float;
public var OneMinusDstAlphaFactor:Float;
public var DstColorFactor:Float;
public var OneMinusDstColorFactor:Float;
public var SrcAlphaSaturateFactor:Float;
public var TextureCount:Float;
public var MultiplyOperation:Float;
public var MixOperation:Float;
public var RepeatWrapping:Float;
public var ClampToEdgeWrapping:Float;
public var MirroredRepeatWrapping:Float;
public var NearestFilter:Float;
public var NearestMipMapNearestFilter:Float;
public var NearestMipMapLinearFilter:Float;
public var LinearFilter:Float;
public var LinearMipMapNearestFilter:Float;
public var LinearMipMapLinearFilter:Float;
public var ByteType:Float;
public var UnsignedByteType:Float;
public var ShortType:Float;
public var UnsignedShortType:Float;
public var IntType:Float;
public var UnsignedIntType:Float;
public var FloatType:Float;
public var AlphaFormat:Float;
public var RGBFormat:Float;
public var RGBAFormat:Float;
public var LuminanceFormat:Float;
public var LuminanceAlphaFormat:Float;
public var LineStrip:Float;
public var LinePieces:Float;
public var PathControlsIdCounter:Float;

public var (Vertex: ()->Void);
public var (AmbientLight: (hex:Dynamic)->Void);
public var (BinaryLoader: (showStatus:Dynamic)->Void);
public var (JSONLoader: (showStatus:Dynamic)->Void);
public var (MeshFaceMaterial: ()->Void);
public var (UVMapping: ()->Void);
public var (CubeReflectionMapping: ()->Void);
public var (CubeRefractionMapping: ()->Void);
public var (SphericalReflectionMapping: ()->Void);
public var (SphericalRefractionMapping: ()->Void);
public var (Curve: ()->Void);
public var (Gyroscope: ()->Void);
public var (AnimationHandler: ()->Void);
public var (TextGeometry: (text:Dynamic,parameters:Dynamic)->Void);
public var (IcosahedronGeometry: (radius:Dynamic,detail:Dynamic)->Void);
public var (OctahedronGeometry: (radius:Dynamic,detail:Dynamic)->Void);
public var (TetrahedronGeometry: (radius:Dynamic,detail:Dynamic)->Void);



}


@:native("x")
extern class x{





}


@:native("vendors")
extern class vendors{





}


@:native("lastTime")
extern class lastTime{





}


@:native("THREE.Clock")
extern class Clock{

public var autoStart:Dynamic;
public var startTime:Float;
public var oldTime:Float;
public var elapsedTime:Float;
public var running:Bool;


public function new (autoStart:Dynamic):Void;

public function start():Void;
public function stop():Void;
public function getElapsedTime():Void;
public function getDelta():Void;

}


@:native("THREE.Color")
extern class Color{

public var r:Float;
public var g:Float;
public var b:Float;


public function new (hex:Dynamic):Void;

public function copy(color):Void;
public function copyGammaToLinear(color):Void;
public function copyLinearToGamma(color):Void;
public function convertGammaToLinear():Void;
public function convertLinearToGamma():Void;
public function setRGB(r,g,b):Void;
public function setHSV(h,s,v):Void;
public function setHex(hex):Void;
public function lerpSelf(color,alpha):Void;
public function getHex():Void;
public function getContextStyle():Void;
public function clone():Void;

}


@:native("THREE.Vector2")
extern class Vector2{



public function new (x:Dynamic,y:Dynamic):Void;

public function set(x,y):Void;
public function copy(v):Void;
public function add(a,b):Void;
public function addSelf(v):Void;
public function sub(a,b):Void;
public function subSelf(v):Void;
public function multiplyScalar(s):Void;
public function divideScalar(s):Void;
public function negate():Void;
public function dot(v):Void;
public function lengthSq():Void;
public function length():Void;
public function normalize():Void;
public function distanceTo(v):Void;
public function distanceToSquared(v):Void;
public function setLength(l):Void;
public function lerpSelf(v,alpha):Void;
public function equals(v):Void;
public function isZero():Void;
public function clone():Void;

}


@:native("THREE.Vector3")
extern class Vector3{



public function new (x:Dynamic,y:Dynamic,z:Dynamic):Void;

public function set(x,y,z):Void;
public function setX(x):Void;
public function setY(y):Void;
public function setZ(z):Void;
public function copy(v):Void;
public function add(a,b):Void;
public function addSelf(v):Void;
public function addScalar(s):Void;
public function sub(a,b):Void;
public function subSelf(v):Void;
public function multiply(a,b):Void;
public function multiplySelf(v):Void;
public function multiplyScalar(s):Void;
public function divideSelf(v):Void;
public function divideScalar(s):Void;
public function negate():Void;
public function dot(v):Void;
public function lengthSq():Void;
public function length():Void;
public function lengthManhattan():Void;
public function normalize():Void;
public function setLength(l):Void;
public function lerpSelf(v,alpha):Void;
public function cross(a,b):Void;
public function crossSelf(v):Void;
public function distanceTo(v):Void;
public function distanceToSquared(v):Void;
public function getPositionFromMatrix(m):Void;
public function getRotationFromMatrix(m,scale):Void;
public function getScaleFromMatrix(m):Void;
public function equals(v):Void;
public function isZero():Void;
public function clone():Void;

}


@:native("THREE.Vector4")
extern class Vector4{

public var w:Dynamic;


public function new (x:Dynamic,y:Dynamic,z:Dynamic,w:Dynamic):Void;

public function set(x,y,z,w):Void;
public function copy(v):Void;
public function add(a,b):Void;
public function addSelf(v):Void;
public function sub(a,b):Void;
public function subSelf(v):Void;
public function multiplyScalar(s):Void;
public function divideScalar(s):Void;
public function negate():Void;
public function dot(v):Void;
public function lengthSq():Void;
public function length():Void;
public function normalize():Void;
public function setLength(l):Void;
public function lerpSelf(v,alpha):Void;
public function clone():Void;

}


@:native("THREE.Frustum")
extern class Frustum{

public var contains:Bool;


public function new ():Void;

public function setFromMatrix(m):Void;

}


@:native("THREE.Ray")
extern class Ray{

public var v:Dynamic;
public var u:Dynamic;
public var invDenom:Dynamic;
public var dot12:Dynamic;
public var dot11:Dynamic;
public var dot02:Dynamic;
public var dot01:Dynamic;
public var dot00:Dynamic;
public var distance:Dynamic;
public var intersect:Dynamic;
public var dot:Dynamic;
public var v2:Dynamic;
public var v1:Dynamic;
public var v0:Dynamic;
public var intersectPoint:Dynamic;
public var normal:Dynamic;
public var vector:Dynamic;
public var directionCopy:Dynamic;
public var originCopy:Dynamic;
public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var precision:Float;

public var (setPrecision: (value:Dynamic)->Void);
public var (intersectObject: (object:Dynamic)->Void);
public var (intersectObjects: (objects:Dynamic)->Void);

public function new (origin:Dynamic,direction:Dynamic):Void;


}


@:native("THREE.Rectangle")
extern class Rectangle{

public var _isEmpty:Bool;
public var _height:Dynamic;
public var _width:Dynamic;
public var _bottom:Float;
public var _right:Float;
public var _top:Float;
public var _left:Float;
public var intersects:Bool;

public var (getX: ()->Void);
public var (getY: ()->Void);
public var (getWidth: ()->Void);
public var (getHeight: ()->Void);
public var (getLeft: ()->Void);
public var (getTop: ()->Void);
public var (getRight: ()->Void);
public var (getBottom: ()->Void);
public var (set: (left:Dynamic,top:Dynamic,right:Dynamic,bottom:Dynamic)->Void);
public var (addPoint: (x:Dynamic,y:Dynamic)->Void);
public var (add3Points: (x1:Dynamic,y1:Dynamic,x2:Dynamic,y2:Dynamic,x3:Dynamic,y3:Dynamic)->Void);
public var (addRectangle: (r:Dynamic)->Void);
public var (inflate: (v:Dynamic)->Void);
public var (minSelf: (r:Dynamic)->Void);
public var (empty: ()->Void);
public var (isEmpty: ()->Void);

public function new ():Void;


}


@:native("THREE.Matrix3")
extern class Matrix3{



public function new ():Void;

public function getInverse(matrix):Void;
public function transpose():Void;
public function transposeIntoArray(r):Void;

}


@:native("THREE.Matrix4")
extern class Matrix4{



public function new (n11:Dynamic,n12:Dynamic,n13:Dynamic,n14:Dynamic,n21:Dynamic,n22:Dynamic,n23:Dynamic,n24:Dynamic,n31:Dynamic,n32:Dynamic,n33:Dynamic,n34:Dynamic,n41:Dynamic,n42:Dynamic,n43:Dynamic,n44:Dynamic):Void;

public function set(n11,n12,n13,n14,n21,n22,n23,n24,n31,n32,n33,n34,n41,n42,n43,n44):Void;
public function identity():Void;
public function copy(m):Void;
public function lookAt(eye,target,up):Void;
public function multiply(a,b):Void;
public function multiplySelf(m):Void;
public function multiplyToArray(a,b,r):Void;
public function multiplyScalar(s):Void;
public function multiplyVector3(v):Void;
public function multiplyVector4(v):Void;
public function rotateAxis(v):Void;
public function crossVector(a):Void;
public function determinant():Void;
public function transpose():Void;
public function flattenToArray(flat):Void;
public function flattenToArrayOffset(flat,offset):Void;
public function getPosition():Void;
public function setPosition(v):Void;
public function getColumnX():Void;
public function getColumnY():Void;
public function getColumnZ():Void;
public function getInverse(m):Void;
public function setRotationFromEuler(v,order):Void;
public function setRotationFromQuaternion(q):Void;
public function compose(translation,rotation,scale):Void;
public function decompose(translation,rotation,scale):Void;
public function extractPosition(m):Void;
public function extractRotation(m):Void;
public function translate(v):Void;
public function rotateX(angle):Void;
public function rotateY(angle):Void;
public function rotateZ(angle):Void;
public function rotateByAxis(axis,angle):Void;
public function scale(v):Void;
public function getMaxScaleOnAxis():Void;
public function makeTranslation(x,y,z):Void;
public function makeRotationX(theta):Void;
public function makeRotationY(theta):Void;
public function makeRotationZ(theta):Void;
public function makeRotationAxis(axis,angle):Void;
public function makeScale(x,y,z):Void;
public function makeFrustum(left,right,bottom,top,near,far):Void;
public function makePerspective(fov,aspect,near,far):Void;
public function makeOrthographic(left,right,top,bottom,near,far):Void;
public function clone():Void;

}


@:native("THREE.Object3D")
extern class Object3D{

public var name:String;
public var eulerOrder:String;
public var doubleSided:Bool;
public var flipSided:Bool;
public var rotationAutoUpdate:Bool;
public var matrixAutoUpdate:Bool;
public var matrixWorldNeedsUpdate:Bool;
public var useQuaternion:Bool;
public var boundRadius:Float;
public var boundRadiusScale:Float;
public var visible:Bool;
public var castShadow:Bool;
public var receiveShadow:Bool;
public var frustumCulled:Bool;


public function new ():Void;

public function applyMatrix(matrix):Void;
public function translate(distance,axis):Void;
public function translateX(distance):Void;
public function translateY(distance):Void;
public function translateZ(distance):Void;
public function lookAt(vector):Void;
public function add(object):Void;
public function remove(object):Void;
public function getChildByName(name,recursive):Void;
public function updateMatrix():Void;
public function updateMatrixWorld(force):Void;

}


@:native("THREE.Projector")
extern class Projector{

public var _face3VertexNormals:Dynamic;
public var _clippedVertex2PositionScreen:Dynamic;
public var _clippedVertex1PositionScreen:Dynamic;
public var _frustum:Dynamic;
public var _projScreenobjectMatrixWorld:Dynamic;
public var _projScreenMatrix:Dynamic;
public var _vector4:Dynamic;
public var _vector3:Dynamic;
public var _renderData:Dynamic;
public var _particlePool:Dynamic;
public var _particleCount:Float;
public var _particle:Dynamic;
public var _linePool:Dynamic;
public var _lineCount:Float;
public var _line:Dynamic;
public var _face4Pool:Dynamic;
public var _face4Count:Float;
public var _face3Pool:Dynamic;
public var _face3Count:Float;
public var _face:Dynamic;
public var _vertexPool:Dynamic;
public var _vertexCount:Dynamic;
public var _vertex:Dynamic;
public var _objectPool:Dynamic;
public var _objectCount:Float;
public var _object:Dynamic;

public var (projectVector: (vector:Dynamic,camera:Dynamic)->Void);
public var (unprojectVector: (vector:Dynamic,camera:Dynamic)->Void);
public var (projectGraph: (root:Dynamic,sort:Dynamic)->Void);
public var (projectScene: (scene:Dynamic,camera:Dynamic,sort:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.Projector.pickingRay")
extern class pickingRay{

public var t:Dynamic;
public var ray:Dynamic;
public var end:Dynamic;


public function new (vector:Dynamic,camera:Dynamic):Void;


}


@:native("THREE.Quaternion")
extern class Quaternion{

public var w:Dynamic;

public var (slerp: (qa:Dynamic,qb:Dynamic,qm:Dynamic,t:Dynamic)->Void);

public function new (x:Dynamic,y:Dynamic,z:Dynamic,w:Dynamic):Void;

public function set(x,y,z,w):Void;
public function copy(q):Void;
public function setFromEuler(vector):Void;
public function setFromAxisAngle(axis,angle):Void;
public function setFromRotationMatrix(m):Void;
public function calculateW():Void;
public function inverse():Void;
public function length():Void;
public function normalize():Void;
public function multiply(a,b):Void;
public function multiplySelf(b):Void;
public function multiplyVector3(vector,dest):Void;
public function clone():Void;

}


@:native("THREE.Face3")
extern class Face3{

public var normal:Dynamic;
public var vertexNormals:Dynamic;
public var color:Dynamic;
public var vertexColors:Dynamic;


public function new (a:Dynamic,b:Dynamic,c:Dynamic,normal:Dynamic,color:Dynamic,materialIndex:Dynamic):Void;

public function clone():Void;

}


@:native("THREE.Face4")
extern class Face4{

public var normal:Dynamic;
public var vertexNormals:Dynamic;
public var color:Dynamic;
public var vertexColors:Dynamic;


public function new (a:Dynamic,b:Dynamic,c:Dynamic,d:Dynamic,normal:Dynamic,color:Dynamic,materialIndex:Dynamic):Void;

public function clone():Void;

}


@:native("THREE.UV")
extern class UV{



public function new (u:Dynamic,v:Dynamic):Void;

public function set(u,v):Void;
public function copy(uv):Void;
public function lerpSelf(uv,alpha):Void;
public function clone():Void;

}


@:native("THREE.Geometry")
extern class Geometry{

public var hasTangents:Bool;
public var dynamic:Bool;


public function new ():Void;

public function applyMatrix(matrix):Void;
public function computeCentroids():Void;
public function computeFaceNormals():Void;
public function computeVertexNormals():Void;
public function computeMorphNormals():Void;
public function computeTangents():Void;
public function computeBoundingBox():Void;
public function computeBoundingSphere():Void;
public function mergeVertices():Void;

}


@:native("THREE.Spline")
extern class Spline{

public var pd:Dynamic;
public var pc:Dynamic;
public var pb:Dynamic;
public var pa:Dynamic;
public var w3:Dynamic;
public var w2:Dynamic;
public var weight:Dynamic;
public var intPoint:Dynamic;
public var point:Dynamic;
public var v3:Dynamic;
public var c:Dynamic;

public var (getPoint: (k:Dynamic)->Void);
public var (getControlPointsArray: ()->Void);

public function new (points:Dynamic):Void;


}


@:native("THREE.Spline.initFromArray")
extern class initFromArray{

public var i:Dynamic;


public function new (a:Dynamic):Void;


}


@:native("THREE.Spline.getLength")
extern class getLength{

public var totalLength:Float;
public var chunkLengths:Dynamic;
public var tmpVec:Dynamic;
public var oldPosition:Dynamic;
public var oldIntPoint:Float;
public var intPoint:Float;
public var point:Float;
public var position:Dynamic;
public var nSamples:Dynamic;
public var index:Dynamic;
public var i:Dynamic;


public function new (nSubDivisions:Dynamic):Void;


}


@:native("THREE.Spline.reparametrizeByArcLength")
extern class reparametrizeByArcLength{

public var sl:Dynamic;
public var tmpVec:Dynamic;
public var newpoints:Dynamic;
public var position:Dynamic;
public var sampling:Dynamic;
public var realDistance:Dynamic;
public var linearDistance:Dynamic;
public var indexNext:Dynamic;
public var indexCurrent:Dynamic;
public var index:Dynamic;
public var j:Dynamic;
public var i:Dynamic;


public function new (samplingCoef:Dynamic):Void;


}


@:native("THREE.Camera")
extern class Camera{



public function new ():Void;

public function lookAt(vector):Void;

}


@:native("THREE.OrthographicCamera")
extern class OrthographicCamera{

public var near:Dynamic;
public var far:Dynamic;


public function new (left:Dynamic,right:Dynamic,top:Dynamic,bottom:Dynamic,near:Dynamic,far:Dynamic):Void;

public function updateProjectionMatrix():Void;

}


@:native("THREE.PerspectiveCamera")
extern class PerspectiveCamera{

public var fov:Dynamic;
public var aspect:Dynamic;
public var near:Dynamic;
public var far:Dynamic;


public function new (fov:Dynamic,aspect:Dynamic,near:Dynamic,far:Dynamic):Void;

public function setLens(focalLength,frameHeight):Void;
public function setViewOffset(fullWidth,fullHeight,x,y,width,height):Void;
public function updateProjectionMatrix():Void;

}


@:native("THREE.Light")
extern class Light{



public function new (hex:Dynamic):Void;


}


@:native("THREE.DirectionalLight")
extern class DirectionalLight{

public var intensity:Dynamic;
public var distance:Dynamic;
public var castShadow:Bool;
public var onlyShadow:Bool;
public var shadowCameraNear:Float;
public var shadowCameraFar:Float;
public var shadowCameraRight:Float;
public var shadowCameraTop:Float;
public var shadowCameraVisible:Bool;
public var shadowBias:Float;
public var shadowDarkness:Float;
public var shadowMapWidth:Float;
public var shadowMapHeight:Float;
public var shadowCascade:Bool;
public var shadowCascadeCount:Float;


public function new (hex:Dynamic,intensity:Dynamic,distance:Dynamic):Void;


}


@:native("THREE.PointLight")
extern class PointLight{

public var intensity:Dynamic;
public var distance:Dynamic;


public function new (hex:Dynamic,intensity:Dynamic,distance:Dynamic):Void;


}


@:native("THREE.SpotLight")
extern class SpotLight{

public var intensity:Dynamic;
public var distance:Dynamic;
public var angle:Dynamic;
public var exponent:Dynamic;
public var castShadow:Bool;
public var onlyShadow:Bool;
public var shadowCameraNear:Float;
public var shadowCameraFar:Float;
public var shadowCameraFov:Float;
public var shadowCameraVisible:Bool;
public var shadowBias:Float;
public var shadowDarkness:Float;
public var shadowMapWidth:Float;
public var shadowMapHeight:Float;


public function new (hex:Dynamic,intensity:Dynamic,distance:Dynamic,angle:Dynamic,exponent:Dynamic):Void;


}


@:native("THREE.Loader")
extern class Loader{

public var statusDomElement:Dynamic;
public var crossOrigin:String;
public var hasNormals:Bool;

public var (onLoadStart: ()->Void);
public var (onLoadProgress: ()->Void);
public var (onLoadComplete: ()->Void);

public function new (showStatus:Dynamic):Void;

public function addStatusElement():Void;
public function updateProgress(progress):Void;
public function extractUrlBase(url):Void;
public function initMaterials(scope,materials,texturePath):Void;
public function createMaterial(m,texturePath):Void;

}


@:native("THREE.SceneLoader")
extern class SceneLoader{


public var (onLoadStart: ()->Void);
public var (onLoadProgress: ()->Void);
public var (onLoadComplete: ()->Void);
public var (callbackSync: ()->Void);
public var (callbackProgress: ()->Void);

public function new ():Void;

public function load(url,callbackFinished):Void;
public function createScene(json,callbackFinished,url):Void;

}


@:native("THREE.Material")
extern class Material{

public var name:String;
public var opacity:Dynamic;
public var transparent:Dynamic;
public var blending:Dynamic;
public var blendSrc:Dynamic;
public var blendDst:Dynamic;
public var blendEquation:Dynamic;
public var depthTest:Dynamic;
public var depthWrite:Dynamic;
public var polygonOffset:Dynamic;
public var polygonOffsetFactor:Dynamic;
public var polygonOffsetUnits:Dynamic;
public var alphaTest:Dynamic;
public var overdraw:Dynamic;
public var visible:Bool;
public var needsUpdate:Bool;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.LineBasicMaterial")
extern class LineBasicMaterial{

public var color:Dynamic;
public var linewidth:Dynamic;
public var linecap:Dynamic;
public var linejoin:Dynamic;
public var vertexColors:Dynamic;
public var fog:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.MeshBasicMaterial")
extern class MeshBasicMaterial{

public var color:Dynamic;
public var map:Dynamic;
public var lightMap:Dynamic;
public var envMap:Dynamic;
public var combine:Dynamic;
public var reflectivity:Dynamic;
public var refractionRatio:Dynamic;
public var fog:Dynamic;
public var shading:Dynamic;
public var wireframe:Dynamic;
public var wireframeLinewidth:Dynamic;
public var wireframeLinecap:Dynamic;
public var wireframeLinejoin:Dynamic;
public var vertexColors:Dynamic;
public var skinning:Dynamic;
public var morphTargets:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.MeshLambertMaterial")
extern class MeshLambertMaterial{

public var color:Dynamic;
public var ambient:Dynamic;
public var emissive:Dynamic;
public var wrapAround:Dynamic;
public var map:Dynamic;
public var lightMap:Dynamic;
public var envMap:Dynamic;
public var combine:Dynamic;
public var reflectivity:Dynamic;
public var refractionRatio:Dynamic;
public var fog:Dynamic;
public var shading:Dynamic;
public var wireframe:Dynamic;
public var wireframeLinewidth:Dynamic;
public var wireframeLinecap:Dynamic;
public var wireframeLinejoin:Dynamic;
public var vertexColors:Dynamic;
public var skinning:Dynamic;
public var morphTargets:Dynamic;
public var morphNormals:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.MeshPhongMaterial")
extern class MeshPhongMaterial{

public var color:Dynamic;
public var ambient:Dynamic;
public var emissive:Dynamic;
public var specular:Dynamic;
public var shininess:Dynamic;
public var metal:Dynamic;
public var perPixel:Dynamic;
public var wrapAround:Dynamic;
public var map:Dynamic;
public var lightMap:Dynamic;
public var envMap:Dynamic;
public var combine:Dynamic;
public var reflectivity:Dynamic;
public var refractionRatio:Dynamic;
public var fog:Dynamic;
public var shading:Dynamic;
public var wireframe:Dynamic;
public var wireframeLinewidth:Dynamic;
public var wireframeLinecap:Dynamic;
public var wireframeLinejoin:Dynamic;
public var vertexColors:Dynamic;
public var skinning:Dynamic;
public var morphTargets:Dynamic;
public var morphNormals:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.MeshDepthMaterial")
extern class MeshDepthMaterial{

public var shading:Dynamic;
public var wireframe:Dynamic;
public var wireframeLinewidth:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.MeshNormalMaterial")
extern class MeshNormalMaterial{

public var shading:Dynamic;
public var wireframe:Dynamic;
public var wireframeLinewidth:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.ParticleBasicMaterial")
extern class ParticleBasicMaterial{

public var color:Dynamic;
public var map:Dynamic;
public var size:Dynamic;
public var sizeAttenuation:Dynamic;
public var vertexColors:Dynamic;
public var fog:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.ParticleCanvasMaterial")
extern class ParticleCanvasMaterial{

public var color:Dynamic;
public var program:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.ParticleDOMMaterial")
extern class ParticleDOMMaterial{



public function new (domElement:Dynamic):Void;


}


@:native("THREE.ShaderMaterial")
extern class ShaderMaterial{

public var fragmentShader:Dynamic;
public var vertexShader:Dynamic;
public var uniforms:Dynamic;
public var shading:Dynamic;
public var wireframe:Dynamic;
public var wireframeLinewidth:Dynamic;
public var fog:Dynamic;
public var lights:Dynamic;
public var vertexColors:Dynamic;
public var skinning:Dynamic;
public var morphTargets:Dynamic;
public var morphNormals:Dynamic;


public function new (parameters:Dynamic):Void;


}


@:native("THREE.Texture")
extern class Texture{

public var mapping:Dynamic;
public var wrapS:Dynamic;
public var wrapT:Dynamic;
public var magFilter:Dynamic;
public var minFilter:Dynamic;
public var format:Dynamic;
public var type:Dynamic;
public var generateMipmaps:Bool;
public var premultiplyAlpha:Bool;
public var needsUpdate:Bool;


public function new (image:Dynamic,mapping:Dynamic,wrapS:Dynamic,wrapT:Dynamic,magFilter:Dynamic,minFilter:Dynamic,format:Dynamic,type:Dynamic):Void;

public function clone():Void;

}


@:native("THREE.DataTexture")
extern class DataTexture{



public function new (data:Dynamic,width:Dynamic,height:Dynamic,format:Dynamic,type:Dynamic,mapping:Dynamic,wrapS:Dynamic,wrapT:Dynamic,magFilter:Dynamic,minFilter:Dynamic):Void;

public function clone():Void;

}


@:native("THREE.Particle")
extern class Particle{



public function new (material:Dynamic):Void;


}


@:native("THREE.ParticleSystem")
extern class ParticleSystem{

public var material:Dynamic;
public var sortParticles:Bool;
public var frustumCulled:Bool;


public function new (geometry:Dynamic,material:Dynamic):Void;


}


@:native("THREE.Line")
extern class Line{

public var material:Dynamic;
public var type:Dynamic;


public function new (geometry:Dynamic,material:Dynamic,type:Dynamic):Void;


}


@:native("THREE.Mesh")
extern class Mesh{

public var m:Dynamic;
public var material:Dynamic;
public var getMorphTargetIndexByName:Float;


public function new (geometry:Dynamic,material:Dynamic):Void;


}


@:native("THREE.Bone")
extern class Bone{



public function new (belongsToSkin:Dynamic):Void;

public function update(parentSkinMatrix,forceUpdate):Void;

}


@:native("THREE.SkinnedMesh")
extern class SkinnedMesh{

public var s:Dynamic;
public var q:Dynamic;
public var p:Dynamic;
public var gbone:Dynamic;
public var bone:Dynamic;
public var b:Dynamic;


public function new (geometry:Dynamic,material:Dynamic):Void;

public function addBone(bone):Void;
public function updateMatrixWorld(force):Void;
public function pose():Void;

}


@:native("THREE.MorphAnimMesh")
extern class MorphAnimMesh{

public var duration:Float;
public var mirroredLoop:Bool;
public var time:Float;
public var lastKeyframe:Float;
public var currentKeyframe:Float;
public var direction:Float;
public var directionBackwards:Bool;


public function new (geometry:Dynamic,material:Dynamic):Void;

public function setFrameRange(start,end):Void;
public function setDirectionForward():Void;
public function setDirectionBackward():Void;
public function parseAnimations():Void;
public function setAnimationLabel(label,start,end):Void;
public function playAnimation(label,fps):Void;
public function updateAnimation(delta):Void;

}


@:native("THREE.Ribbon")
extern class Ribbon{



public function new (geometry:Dynamic,material:Dynamic):Void;


}


@:native("THREE.LOD")
extern class LOD{



public function new ():Void;

public function addLevel(object3D,visibleAtDistance):Void;
public function update(camera):Void;

}


@:native("THREE.Sprite")
extern class Sprite{

public var color:Dynamic;
public var map:Dynamic;
public var blending:Dynamic;
public var blendSrc:Dynamic;
public var blendDst:Dynamic;
public var blendEquation:Dynamic;
public var useScreenCoordinates:Dynamic;
public var mergeWith3D:Dynamic;
public var affectedByDistance:Dynamic;
public var scaleByViewport:Dynamic;
public var alignment:Dynamic;
public var rotation:Float;
public var opacity:Float;


public function new (parameters:Dynamic):Void;

public function updateMatrix():Void;

}


@:native("THREE.Scene")
extern class Scene{

public var matrixAutoUpdate:Bool;


public function new ():Void;

public function __addObject(object):Void;
public function __removeObject(object):Void;

}


@:native("THREE.Fog")
extern class Fog{

public var near:Dynamic;
public var far:Dynamic;


public function new (hex:Dynamic,near:Dynamic,far:Dynamic):Void;


}


@:native("THREE.FogExp2")
extern class FogExp2{

public var density:Dynamic;


public function new (hex:Dynamic,density:Dynamic):Void;


}


@:native("THREE.DOMRenderer")
extern class DOMRenderer{

public var _projector:Dynamic;
public var _transformProp:Dynamic;
public var _heightHalf:Dynamic;
public var _widthHalf:Dynamic;
public var _height:Dynamic;
public var _width:Dynamic;
public var _elements:Dynamic;
public var _renderData:Dynamic;

public var (getSupportedProp: (proparray:Dynamic)->Void);
public var (setSize: (width:Dynamic,height:Dynamic)->Void);
public var (render: (scene:Dynamic,camera:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.CanvasRenderer")
extern class CanvasRenderer{

public var _gradientMapQuality:Float;
public var _gradientMapContext:Dynamic;
public var _gradientMap:Dynamic;
public var _pixelMapData:Dynamic;
public var _pixelMapImage:Dynamic;
public var _pixelMapContext:Dynamic;
public var _pixelMap:Dynamic;
public var _vector3:Dynamic;
public var _pi2:Dynamic;
public var _pointLights:Dynamic;
public var _directionalLights:Dynamic;
public var _ambientLight:Dynamic;
public var _enableLighting:Bool;
public var _bboxRect:Dynamic;
public var _clearRect:Dynamic;
public var _clipRect:Dynamic;
public var _uv3y:Dynamic;
public var _uv3x:Dynamic;
public var _uv2y:Dynamic;
public var _uv2x:Dynamic;
public var _uv1y:Dynamic;
public var _uv1x:Dynamic;
public var _uvs:Dynamic;
public var _image:Dynamic;
public var _far:Dynamic;
public var _near:Dynamic;
public var _imagedatas:Dynamic;
public var _patterns:Dynamic;
public var _color4:Dynamic;
public var _color3:Dynamic;
public var _color2:Dynamic;
public var _color1:Dynamic;
public var _color:Dynamic;
public var _v6y:Dynamic;
public var _v6x:Dynamic;
public var _v5y:Dynamic;
public var _v5x:Dynamic;
public var _v4y:Dynamic;
public var _v4x:Dynamic;
public var _v3y:Dynamic;
public var _v3x:Dynamic;
public var _v2y:Dynamic;
public var _v2x:Dynamic;
public var _v1y:Dynamic;
public var _v1x:Dynamic;
public var _v6:Dynamic;
public var _v5:Dynamic;
public var _v4:Dynamic;
public var _v3:Dynamic;
public var _v2:Dynamic;
public var _v1:Dynamic;
public var _contextLineJoin:Dynamic;
public var _contextLineCap:Dynamic;
public var _contextLineWidth:Dynamic;
public var _contextFillStyle:Dynamic;
public var _contextStrokeStyle:Dynamic;
public var _contextGlobalCompositeOperation:Float;
public var _contextGlobalAlpha:Float;
public var _clearOpacity:Float;
public var _clearColor:Dynamic;
public var _context:Dynamic;
public var _canvasHeightHalf:Dynamic;
public var _canvasWidthHalf:Dynamic;
public var _canvasHeight:Dynamic;
public var _canvasWidth:Dynamic;
public var _canvas:Dynamic;
public var _projector:Dynamic;
public var _lights:Dynamic;
public var _elements:Dynamic;
public var _renderData:Dynamic;
public var _this:Dynamic;
public var autoClear:Bool;
public var sortObjects:Bool;
public var sortElements:Bool;
public var render:Dynamic;

public var (setSize: (width:Dynamic,height:Dynamic)->Void);
public var (setClearColor: (color:Dynamic,opacity:Dynamic)->Void);
public var (setClearColorHex: (hex:Dynamic,opacity:Dynamic)->Void);
public var (clear: ()->Void);

public function new (parameters:Dynamic):Void;


}


@:native("THREE.SVGRenderer")
extern class SVGRenderer{

public var _quality:Float;
public var _lineCount:Float;
public var _circleCount:Float;
public var _pathCount:Float;
public var _svgNode:Dynamic;
public var _svgLinePool:Dynamic;
public var _svgCirclePool:Dynamic;
public var _svgPathPool:Dynamic;
public var _vector3:Dynamic;
public var _w:Dynamic;
public var _pointLights:Dynamic;
public var _directionalLights:Dynamic;
public var _ambientLight:Dynamic;
public var _color:Dynamic;
public var _enableLighting:Bool;
public var _bboxRect:Dynamic;
public var _clipRect:Dynamic;
public var _v4:Dynamic;
public var _v3:Dynamic;
public var _v2:Dynamic;
public var _v1:Dynamic;
public var _svgHeightHalf:Dynamic;
public var _svgWidthHalf:Dynamic;
public var _svgHeight:Dynamic;
public var _svgWidth:Dynamic;
public var _svg:Dynamic;
public var _projector:Dynamic;
public var _lights:Dynamic;
public var _elements:Dynamic;
public var _renderData:Dynamic;
public var _this:Dynamic;
public var autoClear:Bool;
public var sortObjects:Bool;
public var sortElements:Bool;

public var (setQuality: (quality:Dynamic)->Void);
public var (setSize: (width:Dynamic,height:Dynamic)->Void);
public var (clear: ()->Void);
public var (render: (scene:Dynamic,camera:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.WebGLRenderer")
extern class WebGLRenderer{

public var _maxCubemapSize:Dynamic;
public var _maxTextureSize:Dynamic;
public var _maxVertexTextures:Dynamic;
public var _lights:Dynamic;
public var _lightsNeedUpdate:Bool;
public var _direction:Dynamic;
public var _vector3:Dynamic;
public var _projScreenMatrixPS:Dynamic;
public var _projScreenMatrix:Dynamic;
public var _frustum:Dynamic;
public var _currentHeight:Float;
public var _currentWidth:Float;
public var _viewportHeight:Float;
public var _viewportWidth:Float;
public var _viewportY:Float;
public var _viewportX:Float;
public var _oldLineWidth:Dynamic;
public var _oldPolygonOffsetUnits:Dynamic;
public var _oldPolygonOffsetFactor:Dynamic;
public var _oldPolygonOffset:Dynamic;
public var _oldDepthWrite:Dynamic;
public var _oldDepthTest:Dynamic;
public var _oldBlendDst:Dynamic;
public var _oldBlendSrc:Dynamic;
public var _oldBlendEquation:Dynamic;
public var _oldBlending:Dynamic;
public var _oldFlipSided:Dynamic;
public var _oldDoubleSided:Dynamic;
public var _geometryGroupCounter:Float;
public var _currentCamera:Dynamic;
public var _currentGeometryGroupHash:Dynamic;
public var _currentMaterialId:Dynamic;
public var _currentFramebuffer:Dynamic;
public var _currentProgram:Dynamic;
public var _programs:Dynamic;
public var _gl:Dynamic;
public var _this:Dynamic;
public var _maxLights:Dynamic;
public var _clearAlpha:Dynamic;
public var _clearColor:Dynamic;
public var _preserveDrawingBuffer:Dynamic;
public var _stencil:Dynamic;
public var _antialias:Dynamic;
public var _premultipliedAlpha:Dynamic;
public var _alpha:Dynamic;
public var _precision:Dynamic;
public var _canvas:Dynamic;
public var autoClear:Bool;
public var autoClearColor:Bool;
public var autoClearDepth:Bool;
public var autoClearStencil:Bool;
public var sortObjects:Bool;
public var autoUpdateObjects:Bool;
public var autoUpdateScene:Bool;
public var gammaInput:Bool;
public var gammaOutput:Bool;
public var physicallyBasedShading:Bool;
public var shadowMapEnabled:Bool;
public var shadowMapAutoUpdate:Bool;
public var shadowMapSoft:Bool;
public var shadowMapCullFrontFaces:Bool;
public var shadowMapDebug:Bool;
public var shadowMapCascade:Bool;
public var maxMorphTargets:Float;
public var maxMorphNormals:Float;
public var autoScaleCubemaps:Bool;
public var enableScissorTest:Dynamic;

public var (getContext: ()->Void);
public var (supportsVertexTextures: ()->Void);
public var (setViewport: (x:Dynamic,y:Dynamic,width:Dynamic,height:Dynamic)->Void);
public var (setScissor: (x:Dynamic,y:Dynamic,width:Dynamic,height:Dynamic)->Void);
public var (setClearColorHex: (hex:Dynamic,alpha:Dynamic)->Void);
public var (setClearColor: (color:Dynamic,alpha:Dynamic)->Void);
public var (getClearColor: ()->Void);
public var (getClearAlpha: ()->Void);
public var (clear: (color:Dynamic,depth:Dynamic,stencil:Dynamic)->Void);
public var (deallocateObject: (object:Dynamic)->Void);
public var (deallocateTexture: (texture:Dynamic)->Void);
public var (deallocateRenderTarget: (renderTarget:Dynamic)->Void);
public var (renderBufferImmediate: (object:Dynamic,program:Dynamic,shading:Dynamic)->Void);
public var (renderBufferDirect: (camera:Dynamic,lights:Dynamic,fog:Dynamic,material:Dynamic,geometryGroup:Dynamic,object:Dynamic)->Void);
public var (renderBuffer: (camera:Dynamic,lights:Dynamic,fog:Dynamic,material:Dynamic,geometryGroup:Dynamic,object:Dynamic)->Void);
public var (renderImmediateObject: (camera:Dynamic,lights:Dynamic,fog:Dynamic,material:Dynamic,object:Dynamic)->Void);
public var (initWebGLObjects: (scene:Dynamic)->Void);
public var (initMaterial: (material:Dynamic,lights:Dynamic,fog:Dynamic,object:Dynamic)->Void);
public var (setFaceCulling: (cullFace:Dynamic,frontFace:Dynamic)->Void);
public var (setObjectFaces: (object:Dynamic)->Void);
public var (setDepthTest: (depthTest:Dynamic)->Void);
public var (setDepthWrite: (depthWrite:Dynamic)->Void);
public var (setBlending: (blending:Dynamic,blendEquation:Dynamic,blendSrc:Dynamic,blendDst:Dynamic)->Void);
public var (setTexture: (texture:Dynamic,slot:Dynamic)->Void);
public var (setRenderTarget: (renderTarget:Dynamic)->Void);

public function new (parameters:Dynamic):Void;


}


@:native("THREE.WebGLRenderer.setSize")
extern class setSize{



public function new (width:Dynamic,height:Dynamic):Void;


}


@:native("THREE.WebGLRenderer.clearTarget")
extern class clearTarget{



public function new (renderTarget:Dynamic,color:Dynamic,depth:Dynamic,stencil:Dynamic):Void;


}


@:native("THREE.WebGLRenderer.addPostPlugin")
extern class addPostPlugin{



public function new (plugin:Dynamic):Void;


}


@:native("THREE.WebGLRenderer.addPrePlugin")
extern class addPrePlugin{



public function new (plugin:Dynamic):Void;


}


@:native("THREE.WebGLRenderer.updateShadowMap")
extern class updateShadowMap{



public function new (scene:Dynamic,camera:Dynamic):Void;


}


@:native("THREE.WebGLRenderer.render")
extern class render{

public var material:Dynamic;
public var fog:Dynamic;
public var lights:Dynamic;
public var renderList:Dynamic;
public var object:Dynamic;
public var webglObject:Dynamic;
public var il:Dynamic;
public var i:Dynamic;


public function new (scene:Dynamic,camera:Dynamic,renderTarget:Dynamic,forceClear:Dynamic):Void;


}


@:native("THREE.WebGLRenderTarget")
extern class WebGLRenderTarget{

public var wrapS:Dynamic;
public var wrapT:Dynamic;
public var magFilter:Dynamic;
public var minFilter:Dynamic;
public var format:Dynamic;
public var type:Dynamic;
public var depthBuffer:Dynamic;
public var stencilBuffer:Dynamic;
public var generateMipmaps:Bool;


public function new (width:Dynamic,height:Dynamic,options:Dynamic):Void;

public function clone():Void;

}


@:native("THREE.WebGLRenderTargetCube")
extern class WebGLRenderTargetCube{

public var activeCubeFace:Float;


public function new (width:Dynamic,height:Dynamic,options:Dynamic):Void;


}


@:native("THREE.RenderableVertex")
extern class RenderableVertex{

public var visible:Bool;


public function new ():Void;

public function copy(vertex):Void;

}


@:native("THREE.RenderableFace3")
extern class RenderableFace3{



public function new ():Void;


}


@:native("THREE.RenderableFace4")
extern class RenderableFace4{



public function new ():Void;


}


@:native("THREE.RenderableObject")
extern class RenderableObject{



public function new ():Void;


}


@:native("THREE.RenderableParticle")
extern class RenderableParticle{



public function new ():Void;


}


@:native("THREE.RenderableLine")
extern class RenderableLine{



public function new ():Void;


}


@:native("THREE.BufferGeometry")
extern class BufferGeometry{

public var dynamic:Bool;


public function new ():Void;

public function computeBoundingBox():Void;
public function computeBoundingSphere():Void;

}


@:native("THREE.LineCurve")
extern class LineCurve{



public function new (v1:Dynamic,v2:Dynamic):Void;

public function getPoint(t):Void;
public function getPointAt(u):Void;
public function getTangent(t):Void;

}


@:native("THREE.QuadraticBezierCurve")
extern class QuadraticBezierCurve{



public function new (v0:Dynamic,v1:Dynamic,v2:Dynamic):Void;

public function getPoint(t):Void;
public function getTangent(t):Void;

}


@:native("THREE.CubicBezierCurve")
extern class CubicBezierCurve{



public function new (v0:Dynamic,v1:Dynamic,v2:Dynamic,v3:Dynamic):Void;

public function getPoint(t):Void;
public function getTangent(t):Void;

}


@:native("THREE.SplineCurve")
extern class SplineCurve{

public var points:Dynamic;


public function new (points:Dynamic):Void;

public function getPoint(t):Void;

}


@:native("THREE.ArcCurve")
extern class ArcCurve{



public function new (aX:Dynamic,aY:Dynamic,aRadius:Dynamic,aStartAngle:Dynamic,aEndAngle:Dynamic,aClockwise:Dynamic):Void;

public function getPoint(t):Void;

}


@:native("THREE.CurvePath")
extern class CurvePath{

public var autoClose:Bool;


public function new ():Void;

public function add(curve):Void;
public function checkConnection():Void;
public function closePath():Void;
public function getPoint(t):Void;
public function getLength():Void;
public function getCurveLengths():Void;
public function getBoundingBox():Void;
public function createPointsGeometry(divisions):Void;
public function createSpacedPointsGeometry(divisions):Void;
public function createGeometry(points):Void;
public function addWrapPath(bendpath):Void;
public function getTransformedPoints(segments,bends):Void;
public function getTransformedSpacedPoints(segments,bends):Void;
public function getWrapPoints(oldPts,path):Void;

}


@:native("THREE.EventTarget")
extern class EventTarget{

public var listeners:Dynamic;

public var (addEventListener: (type:Dynamic,listener:Dynamic)->Void);
public var (dispatchEvent: (event:Dynamic)->Void);
public var (removeEventListener: (type:Dynamic,listener:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.Path")
extern class Path{



public function new (points:Dynamic):Void;

public function fromPoints(vectors):Void;
public function moveTo(x,y):Void;
public function lineTo(x,y):Void;
public function quadraticCurveTo(aCPx,aCPy,aX,aY):Void;
public function bezierCurveTo(aCP1x,aCP1y,aCP2x,aCP2y,aX,aY):Void;
public function splineThru(pts):Void;
public function arc(aX,aY,aRadius,aStartAngle,aEndAngle,aClockwise):Void;
public function absarc(aX,aY,aRadius,aStartAngle,aEndAngle,aClockwise):Void;
public function getSpacedPoints(divisions,closedPath):Void;
public function getPoints(divisions,closedPath):Void;
public function transform(path,segments):Void;
public function nltransform(a,b,c,d,e,f):Void;
public function debug(canvas):Void;
public function toShapes():Void;

}


@:native("THREE.Shape")
extern class Shape{



public function new ():Void;

public function extrude(options):Void;
public function getPointsHoles(divisions):Void;
public function getSpacedPointsHoles(divisions):Void;
public function extractAllPoints(divisions):Void;
public function extractPoints(divisions):Void;
public function extractAllSpacedPoints(divisions):Void;

}


@:native("THREE.TextPath")
extern class TextPath{



public function new (text:Dynamic,parameters:Dynamic):Void;

public function set(text,parameters):Void;
public function toShapes():Void;

}


@:native("THREE.Animation")
extern class Animation{

public var currentTime:Float;
public var timeScale:Float;
public var isPlaying:Bool;
public var isPaused:Bool;
public var loop:Bool;
public var interpolationType:Dynamic;
public var JITCompile:Dynamic;


public function new (root:Dynamic,data:Dynamic,interpolationType:Dynamic,JITCompile:Dynamic):Void;

public function play(loop,startTimeMS):Void;
public function pause():Void;
public function stop():Void;
public function update(deltaTimeMS):Void;
public function interpolateCatmullRom(points,scale):Void;
public function interpolate(p0,p1,p2,p3,t,t2,t3):Void;
public function getNextKeyWith(type,h,key):Void;
public function getPrevKeyWith(type,h,key):Void;

}


@:native("THREE.KeyFrameAnimation")
extern class KeyFrameAnimation{

public var next:Dynamic;
public var sid:Dynamic;
public var s:Dynamic;
public var obj:Dynamic;
public var sids:Dynamic;
public var keys:Dynamic;
public var hl:Dynamic;
public var h:Dynamic;
public var currentTime:Float;
public var timeScale:Float;
public var isPlaying:Bool;
public var isPaused:Bool;
public var loop:Bool;
public var JITCompile:Dynamic;


public function new (root:Dynamic,data:Dynamic,JITCompile:Dynamic):Void;

public function play(loop,startTimeMS):Void;
public function pause():Void;
public function stop():Void;
public function update(deltaTimeMS):Void;
public function getNextKeyWith(sid,h,key):Void;
public function getPrevKeyWith(sid,h,key):Void;

}


@:native("THREE.CubeCamera")
extern class CubeCamera{

public var cameraNZ:Dynamic;
public var cameraPZ:Dynamic;
public var cameraNY:Dynamic;
public var cameraPY:Dynamic;
public var cameraNX:Dynamic;
public var cameraPX:Dynamic;
public var aspect:Float;
public var fov:Float;

public var (updateCubeMap: (renderer:Dynamic,scene:Dynamic)->Void);

public function new (near:Dynamic,far:Dynamic,cubeResolution:Dynamic):Void;


}


@:native("THREE.CombinedCamera")
extern class CombinedCamera{

public var aspect:Dynamic;
public var zoom:Float;


public function new (width:Dynamic,height:Dynamic,fov:Dynamic,near:Dynamic,far:Dynamic,orthonear:Dynamic,orthofar:Dynamic):Void;

public function toPerspective():Void;
public function toOrthographic():Void;
public function setSize(width,height):Void;
public function setFov(fov):Void;
public function updateProjectionMatrix():Void;
public function setLens(focalLength,frameHeight):Void;
public function setZoom(zoom):Void;
public function toFrontView():Void;
public function toBackView():Void;
public function toLeftView():Void;
public function toRightView():Void;
public function toTopView():Void;
public function toBottomView():Void;

}


@:native("THREE.FirstPersonControls")
extern class FirstPersonControls{

public var domElement:Dynamic;
public var movementSpeed:Float;
public var lookSpeed:Float;
public var noFly:Bool;
public var lookVertical:Bool;
public var autoForward:Bool;
public var activeLook:Bool;
public var heightSpeed:Bool;
public var heightCoef:Float;
public var heightMin:Float;
public var constrainVertical:Bool;
public var verticalMin:Float;
public var autoSpeedFactor:Float;
public var mouseX:Float;
public var mouseY:Float;
public var lat:Float;
public var lon:Float;
public var phi:Float;
public var theta:Float;
public var moveForward:Bool;
public var moveBackward:Bool;
public var moveLeft:Bool;
public var moveRight:Bool;
public var freeze:Bool;
public var mouseDragOn:Bool;

public var (onMouseMove: (event:Dynamic)->Void);
public var (onKeyDown: (event:Dynamic)->Void);
public var (onKeyUp: (event:Dynamic)->Void);

public function new (object:Dynamic,domElement:Dynamic):Void;


}


@:native("THREE.FirstPersonControls.onMouseDown")
extern class onMouseDown{

public var mouseDragOn:Bool;


public function new (event:Dynamic):Void;


}


@:native("THREE.FirstPersonControls.onMouseUp")
extern class onMouseUp{

public var mouseDragOn:Bool;


public function new (event:Dynamic):Void;


}


@:native("THREE.FirstPersonControls.update")
extern class update{

public var position:Dynamic;
public var targetPosition:Dynamic;
public var verticalLookRatio:Float;
public var actualLookSpeed:Dynamic;
public var heightDelta:Dynamic;
public var y:Dynamic;
public var actualMoveSpeed:Float;


public function new (delta:Dynamic):Void;


}


@:native("THREE.PathControls")
extern class PathControls{

public var PI180:Dynamic;
public var PI2:Dynamic;
public var domElement:Dynamic;
public var useConstantSpeed:Bool;
public var resamplingCoef:Float;
public var lookSpeed:Float;
public var lookVertical:Bool;
public var lookHorizontal:Bool;
public var mouseX:Float;
public var mouseY:Float;
public var lat:Float;
public var lon:Float;
public var phi:Float;
public var theta:Float;

public var (onMouseMove: (event:Dynamic)->Void);

public function new (object:Dynamic,domElement:Dynamic):Void;


}


@:native("THREE.PathControls.update")
extern class update{

public var position:Dynamic;
public var targetPosition:Dynamic;
public var tmpThetaNormalized:Dynamic;
public var tmpThetaFullRange:Dynamic;
public var tmpTheta:Dynamic;
public var tmpPhiNormalized:Dynamic;
public var tmpPhiFullRange:Dynamic;
public var tmpPhi:Dynamic;
public var dstRange:Dynamic;
public var srcRange:Dynamic;


public function new (delta:Dynamic):Void;


}


@:native("THREE.PathControls.init")
extern class init{

public var dummyChild:Dynamic;
public var dummyChildGeo:Dynamic;
public var dummyParentGeo:Dynamic;
public var dummyChildMaterial:Dynamic;
public var dummyParentMaterial:Dynamic;


public function new ():Void;


}


@:native("THREE.FlyControls")
extern class FlyControls{

public var domElement:Dynamic;
public var movementSpeed:Float;
public var rollSpeed:Float;
public var dragToLook:Bool;
public var autoForward:Bool;
public var useQuaternion:Bool;
public var mouseStatus:Float;

public var (handleEvent: (event:Dynamic)->Void);
public var (mousedown: (event:Dynamic)->Void);
public var (mousemove: (event:Dynamic)->Void);
public var (getContainerDimensions: ()->Void);

public function new (object:Dynamic,domElement:Dynamic):Void;


}


@:native("THREE.FlyControls.keydown")
extern class keydown{



public function new (event:Dynamic):Void;


}


@:native("THREE.FlyControls.keyup")
extern class keyup{



public function new (event:Dynamic):Void;


}


@:native("THREE.FlyControls.mouseup")
extern class mouseup{



public function new (event:Dynamic):Void;


}


@:native("THREE.FlyControls.update")
extern class update{

public var rotMult:Dynamic;
public var moveMult:Dynamic;
public var matrixWorldNeedsUpdate:Bool;


public function new (delta:Dynamic):Void;


}


@:native("THREE.FlyControls.updateMovementVector")
extern class updateMovementVector{

public var forward:Dynamic;


public function new ():Void;


}


@:native("THREE.FlyControls.updateRotationVector")
extern class updateRotationVector{



public function new ():Void;


}


@:native("THREE.RollControls")
extern class RollControls{

public var windowHalfY:Dynamic;
public var windowHalfX:Dynamic;
public var mouseY:Float;
public var mouseX:Float;
public var upSpeed:Float;
public var sideSpeed:Float;
public var forwardSpeed:Float;
public var rollDirection:Float;
public var doRoll:Bool;
public var rollMatrix:Dynamic;
public var zTemp:Dynamic;
public var yTemp:Dynamic;
public var xTemp:Dynamic;
public var domElement:Dynamic;
public var mouseLook:Bool;
public var autoForward:Bool;
public var lookSpeed:Float;
public var movementSpeed:Float;
public var rollSpeed:Float;
public var matrixAutoUpdate:Bool;
public var roll:Float;


public function new (object:Dynamic,domElement:Dynamic):Void;


}


@:native("THREE.RollControls.update")
extern class update{

public var forwardOrAuto:Dynamic;
public var actualSpeed:Dynamic;
public var actualLookSpeed:Dynamic;
public var matrixWorldNeedsUpdate:Bool;


public function new (delta:Dynamic):Void;


}


@:native("THREE.RollControls.translateX")
extern class translateX{



public function new (distance:Dynamic):Void;


}


@:native("THREE.RollControls.translateY")
extern class translateY{



public function new (distance:Dynamic):Void;


}


@:native("THREE.RollControls.translateZ")
extern class translateZ{



public function new (distance:Dynamic):Void;


}


@:native("THREE.RollControls.rotateHorizontally")
extern class rotateHorizontally{



public function new (amount:Dynamic):Void;


}


@:native("THREE.RollControls.rotateVertically")
extern class rotateVertically{



public function new (amount:Dynamic):Void;


}


@:native("THREE.TrackballControls")
extern class TrackballControls{

public var changeEvent:Dynamic;
public var _panEnd:Dynamic;
public var _panStart:Dynamic;
public var _zoomEnd:Dynamic;
public var _zoomStart:Dynamic;
public var _rotateEnd:Dynamic;
public var _rotateStart:Dynamic;
public var _eye:Dynamic;
public var _state:Dynamic;
public var _keyPressed:Bool;
public var lastPosition:Dynamic;
public var STATE:Dynamic;
public var _this:Dynamic;
public var domElement:Dynamic;
public var enabled:Bool;
public var rotateSpeed:Float;
public var zoomSpeed:Float;
public var panSpeed:Float;
public var noRotate:Bool;
public var noZoom:Bool;
public var noPan:Bool;
public var staticMoving:Bool;
public var dynamicDampingFactor:Float;
public var minDistance:Float;

public var (handleEvent: (event:Dynamic)->Void);
public var (getMouseOnScreen: (clientX:Dynamic,clientY:Dynamic)->Void);
public var (getMouseProjectionOnBall: (clientX:Dynamic,clientY:Dynamic)->Void);
public var (rotateCamera: ()->Void);
public var (zoomCamera: ()->Void);
public var (panCamera: ()->Void);
public var (checkDistances: ()->Void);
public var (update: ()->Void);

public function new (object:Dynamic,domElement:Dynamic):Void;


}


@:native("THREE.CubeGeometry")
extern class CubeGeometry{

public var s:Dynamic;
public var i:Dynamic;
public var mnz:Dynamic;
public var mny:Dynamic;
public var mnx:Dynamic;
public var mpz:Dynamic;
public var mpy:Dynamic;
public var mpx:Dynamic;
public var depth_half:Dynamic;
public var height_half:Dynamic;
public var width_half:Dynamic;
public var scope:Dynamic;


public function new (width:Dynamic,height:Dynamic,depth:Dynamic,segmentsWidth:Dynamic,segmentsHeight:Dynamic,segmentsDepth:Dynamic,materials:Dynamic,sides:Dynamic):Void;


}


@:native("THREE.CylinderGeometry")
extern class CylinderGeometry{

public var uv3:Dynamic;
public var uv2:Dynamic;
public var uv1:Dynamic;
public var n3:Dynamic;
public var n2:Dynamic;
public var n1:Dynamic;
public var v3:Dynamic;
public var v2:Dynamic;
public var v1:Dynamic;
public var uv4:Dynamic;
public var n4:Dynamic;
public var v4:Dynamic;
public var nb:Dynamic;
public var na:Dynamic;
public var tanTheta:Dynamic;
public var vertex:Dynamic;
public var u:Dynamic;
public var radius:Dynamic;
public var v:Dynamic;
public var uvsRow:Dynamic;
public var verticesRow:Dynamic;
public var uvs:Dynamic;
public var vertices:Dynamic;
public var y:Dynamic;
public var x:Dynamic;
public var segmentsY:Dynamic;
public var segmentsX:Dynamic;
public var heightHalf:Dynamic;


public function new (radiusTop:Dynamic,radiusBottom:Dynamic,height:Dynamic,segmentsRadius:Dynamic,segmentsHeight:Dynamic,openEnded:Dynamic):Void;


}


@:native("THREE.ExtrudeGeometry")
extern class ExtrudeGeometry{



public function new (shapes:Dynamic,options:Dynamic):Void;

public function addShapeList(shapes,options):Void;
public function addShape(shape,options):Void;

}


@:native("THREE.LatheGeometry")
extern class LatheGeometry{

public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var kl:Dynamic;
public var k:Dynamic;
public var j:Dynamic;
public var il:Dynamic;
public var i:Dynamic;
public var _matrix:Dynamic;
public var _newV:Dynamic;
public var _angle:Dynamic;
public var _steps:Dynamic;


public function new (points:Dynamic,steps:Dynamic,angle:Dynamic):Void;


}


@:native("THREE.PlaneGeometry")
extern class PlaneGeometry{

public var face:Dynamic;
public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var z:Dynamic;
public var x:Dynamic;
public var normal:Dynamic;
public var segment_depth:Dynamic;
public var segment_width:Dynamic;
public var gridZ1:Dynamic;
public var gridX1:Dynamic;
public var gridZ:Dynamic;
public var gridX:Dynamic;
public var depth_half:Dynamic;
public var width_half:Dynamic;
public var iz:Dynamic;
public var ix:Dynamic;


public function new (width:Dynamic,depth:Dynamic,segmentsWidth:Dynamic,segmentsDepth:Dynamic):Void;


}


@:native("THREE.SphereGeometry")
extern class SphereGeometry{

public var uv4:Dynamic;
public var uv3:Dynamic;
public var uv2:Dynamic;
public var uv1:Dynamic;
public var n4:Dynamic;
public var n3:Dynamic;
public var n2:Dynamic;
public var n1:Dynamic;
public var v4:Dynamic;
public var v3:Dynamic;
public var v2:Dynamic;
public var v1:Dynamic;
public var vertex:Dynamic;
public var v:Dynamic;
public var u:Dynamic;
public var uvsRow:Dynamic;
public var verticesRow:Dynamic;
public var uvs:Dynamic;
public var vertices:Dynamic;
public var y:Dynamic;
public var x:Dynamic;
public var segmentsY:Dynamic;
public var segmentsX:Dynamic;


public function new (radius:Dynamic,segmentsWidth:Dynamic,segmentsHeight:Dynamic,phiStart:Dynamic,phiLength:Dynamic,thetaStart:Dynamic,thetaLength:Dynamic):Void;


}


@:native("snip")
extern class snip{

public var py:Dynamic;
public var px:Dynamic;
public var cy:Dynamic;
public var cx:Dynamic;
public var by:Dynamic;
public var bx:Dynamic;
public var ay:Dynamic;
public var ax:Dynamic;
public var p:Dynamic;




}


@:native("insideTriangle")
extern class insideTriangle{

public var aCROSSbp:Dynamic;
public var bCROSScp:Dynamic;
public var cCROSSap:Dynamic;
public var cpy:Dynamic;
public var cpx:Dynamic;
public var bpy:Dynamic;
public var bpx:Dynamic;
public var apy:Dynamic;
public var apx:Dynamic;
public var cY:Dynamic;
public var cX:Dynamic;
public var bY:Dynamic;
public var bX:Dynamic;
public var aY:Dynamic;
public var aX:Dynamic;




}


@:native("area")
extern class area{

public var q:Dynamic;
public var p:Dynamic;
public var a:Float;
public var n:Dynamic;




}


@:native("process")
extern class process{

public var t:Dynamic;
public var s:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var count:Dynamic;
public var nv:Dynamic;
public var w:Dynamic;
public var v:Dynamic;
public var u:Dynamic;
public var vertIndices:Dynamic;
public var verts:Dynamic;
public var result:Dynamic;
public var n:Dynamic;




}


@:native("EPSILON")
extern class EPSILON{





}


@:native("THREE.TorusGeometry")
extern class TorusGeometry{

public var face:Dynamic;
public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var i:Dynamic;
public var j:Dynamic;
public var vertex:Dynamic;
public var v:Dynamic;
public var u:Dynamic;
public var normals:Dynamic;
public var uvs:Dynamic;
public var center:Dynamic;
public var scope:Dynamic;


public function new (radius:Dynamic,tube:Dynamic,segmentsR:Dynamic,segmentsT:Dynamic,arc:Dynamic):Void;


}


@:native("THREE.TorusKnotGeometry")
extern class TorusKnotGeometry{

public var uvd:Dynamic;
public var uvc:Dynamic;
public var uvb:Dynamic;
public var uva:Dynamic;
public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var jp:Dynamic;
public var ip:Dynamic;
public var j:Dynamic;
public var i:Dynamic;
public var cy:Dynamic;
public var cx:Dynamic;
public var p2:Dynamic;
public var p1:Dynamic;
public var v:Dynamic;
public var u:Dynamic;
public var bitan:Dynamic;
public var n:Dynamic;
public var tang:Dynamic;
public var scope:Dynamic;


public function new (radius:Dynamic,tube:Dynamic,segmentsR:Dynamic,segmentsT:Dynamic,p:Dynamic,q:Dynamic,heightScale:Dynamic):Void;


}


@:native("THREE.TubeGeometry")
extern class TubeGeometry{

public var binormals:Dynamic;
public var normals:Dynamic;
public var tangents:Dynamic;
public var frames:Dynamic;
public var uvd:Dynamic;
public var uvc:Dynamic;
public var uvb:Dynamic;
public var uva:Dynamic;
public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var jp:Dynamic;
public var ip:Dynamic;
public var j:Dynamic;
public var i:Dynamic;
public var pos2:Dynamic;
public var pos:Dynamic;
public var cy:Dynamic;
public var cx:Dynamic;
public var v:Dynamic;
public var u:Dynamic;
public var tz:Dynamic;
public var ty:Dynamic;
public var tx:Dynamic;
public var z:Dynamic;
public var y:Dynamic;
public var x:Dynamic;
public var numpoints:Dynamic;
public var binormal:Dynamic;
public var normal:Dynamic;
public var tangent:Dynamic;
public var scope:Dynamic;


public function new (path:Dynamic,segments:Dynamic,radius:Dynamic,segmentsRadius:Dynamic,closed:Dynamic,debug:Dynamic):Void;


}


@:native("THREE.TubeGeometry.FrenetFrames")
extern class FrenetFrames{

public var v:Dynamic;
public var u:Dynamic;
public var i:Dynamic;
public var tz:Dynamic;
public var ty:Dynamic;
public var tx:Dynamic;
public var smallest:Dynamic;
public var epsilon:Float;
public var theta:Dynamic;
public var numpoints:Dynamic;
public var mat:Dynamic;
public var vec:Dynamic;
public var binormals:Dynamic;
public var normals:Dynamic;
public var tangents:Dynamic;
public var binormal:Dynamic;
public var normal:Dynamic;
public var tangent:Dynamic;


public function new (path:Dynamic,segments:Dynamic,closed:Dynamic):Void;


}


@:native("THREE.PolyhedronGeometry")
extern class PolyhedronGeometry{

public var l:Dynamic;
public var i:Dynamic;
public var p:Dynamic;
public var midpoints:Dynamic;
public var that:Dynamic;


public function new (vertices:Dynamic,faces:Dynamic,radius:Dynamic,detail:Dynamic):Void;


}


@:native("THREE.ParametricGeometry")
extern class ParametricGeometry{

public var uvd:Dynamic;
public var uvc:Dynamic;
public var uvb:Dynamic;
public var uva:Dynamic;
public var d:Dynamic;
public var c:Dynamic;
public var b:Dynamic;
public var a:Dynamic;
public var sliceCount:Dynamic;
public var stackCount:Dynamic;
public var v:Dynamic;
public var u:Dynamic;
public var p:Dynamic;
public var j:Dynamic;
public var il:Dynamic;
public var i:Dynamic;
public var uvs:Dynamic;
public var faces:Dynamic;
public var verts:Dynamic;


public function new (func:Dynamic,slices:Dynamic,stacks:Dynamic,useTris:Dynamic):Void;


}


@:native("THREE.AxisHelper")
extern class AxisHelper{

public var cone:Dynamic;
public var line:Dynamic;
public var coneGeometry:Dynamic;
public var lineGeometry:Dynamic;


public function new ():Void;


}


@:native("THREE.ArrowHelper")
extern class ArrowHelper{

public var coneGeometry:Dynamic;
public var lineGeometry:Dynamic;


public function new (dir:Dynamic,origin:Dynamic,length:Dynamic,hex:Dynamic):Void;

public function setDirection(dir):Void;
public function setLength(length):Void;
public function setColor(hex):Void;

}


@:native("THREE.CameraHelper")
extern class CameraHelper{

public var hexCross:Float;
public var hexTarget:Float;
public var hexUp:Float;
public var hexCone:Float;
public var hexFrustum:Float;
public var _this:Dynamic;


public function new (camera:Dynamic):Void;

public function update():Void;

}


@:native("THREE.SubdivisionModifier")
extern class SubdivisionModifier{

public var subdivisions:Dynamic;
public var useOldVertexColors:Bool;
public var supportUVs:Bool;
public var debug:Bool;


public function new (subdivisions:Dynamic):Void;

public function modify(geometry):Void;
public function smooth(oldGeometry):Void;

}


@:native("THREE.ImmediateRenderObject")
extern class ImmediateRenderObject{


public var (render: (renderCallback:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.LensFlare")
extern class LensFlare{



public function new (texture:Dynamic,size:Dynamic,distance:Dynamic,blending:Dynamic,color:Dynamic):Void;

public function add(texture,size,distance,blending,color,opacity):Void;
public function updateLensFlares():Void;

}


@:native("THREE.MorphBlendMesh")
extern class MorphBlendMesh{

public var fps:Dynamic;
public var endFrame:Dynamic;
public var startFrame:Float;
public var name:String;
public var numFrames:Dynamic;


public function new (geometry:Dynamic,material:Dynamic):Void;

public function createAnimation(name,start,end,fps):Void;
public function autoCreateAnimations(fps):Void;
public function setAnimationDirectionForward(name):Void;
public function setAnimationDirectionBackward(name):Void;
public function setAnimationFPS(name,fps):Void;
public function setAnimationDuration(name,duration):Void;
public function setAnimationWeight(name,weight):Void;
public function setAnimationTime(name,time):Void;
public function getAnimationTime(name):Void;
public function getAnimationDuration(name):Void;
public function playAnimation(name):Void;
public function stopAnimation(name):Void;
public function update(delta):Void;

}


@:native("THREE.LensFlarePlugin")
extern class LensFlarePlugin{

public var _lensFlare:Dynamic;
public var _renderer:Dynamic;
public var _gl:Dynamic;

public var (init: (renderer:Dynamic)->Void);
public var (render: (scene:Dynamic,camera:Dynamic,viewportWidth:Dynamic,viewportHeight:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.ShadowMapPlugin")
extern class ShadowMapPlugin{

public var _max:Dynamic;
public var _min:Dynamic;
public var _projScreenMatrix:Dynamic;
public var _frustum:Dynamic;
public var _depthMaterialMorph:Dynamic;
public var _depthMaterial:Dynamic;
public var _renderer:Dynamic;
public var _gl:Dynamic;

public var (init: (renderer:Dynamic)->Void);
public var (update: (scene:Dynamic,camera:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.ShadowMapPlugin.render")
extern class render{



public function new (scene:Dynamic,camera:Dynamic):Void;


}


@:native("THREE.SpritePlugin")
extern class SpritePlugin{

public var _sprite:Dynamic;
public var _renderer:Dynamic;
public var _gl:Dynamic;

public var (init: (renderer:Dynamic)->Void);
public var (render: (scene:Dynamic,camera:Dynamic,viewportWidth:Dynamic,viewportHeight:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.DepthPassPlugin")
extern class DepthPassPlugin{

public var _projScreenMatrix:Dynamic;
public var _frustum:Dynamic;
public var _depthMaterialMorph:Dynamic;
public var _depthMaterial:Dynamic;
public var _renderer:Dynamic;
public var _gl:Dynamic;
public var enabled:Bool;

public var (init: (renderer:Dynamic)->Void);
public var (update: (scene:Dynamic,camera:Dynamic)->Void);

public function new ():Void;


}


@:native("THREE.DepthPassPlugin.render")
extern class render{



public function new (scene:Dynamic,camera:Dynamic):Void;


}


